
;****************************************************************************\
;*									       *
;* prsht.h - - Interface for the Windows Property Sheet Pages		       *
;*									       *
;* Version 1.0								       *
;*									       *
;* Copyright (c) 1991-1998, Microsoft Corp.	 All rights reserved.	       *
;*									       *
;\****************************************************************************

MAXPROPPAGES			= 100

proctype FNPSPCALLBACK :dword, :dword, :dword

PSP_DEFAULT			= 000000000h
PSP_DLGINDIRECT 		= 000000001h
PSP_USEHICON			= 000000002h
PSP_USEICONID			= 000000004h
PSP_USETITLE			= 000000008h
PSP_RTLREADING			= 000000010h

PSP_HASHELP			= 000000020h
PSP_USEREFPARENT		= 000000040h
PSP_USECALLBACK 		= 000000080h
PSP_PREMATURE			= 000000400h

;----- New flags for wizard97 --------------
PSP_HIDEHEADER			= 000000800h
PSP_USEHEADERTITLE		= 000001000h
PSP_USEHEADERSUBTITLE		= 000002000h
;-------------------------------------------

PSPCB_ADDREF			= 0
PSPCB_RELEASE			= 1
PSPCB_CREATE			= 2

struc	PROPSHEETPAGE
	dwSize			dd ?
	dwFlags 		dd ?
	hInstance		dd ?
label	pszTemplate		dword
	pResource		dd ?
label	hIcon			dword
	pszIcon 		dd ?
	pszTitle		dd ?
	pfnDlgProc		dd ?
	lParam			dd ?
	pfnCallback		dd ?
	pcRefParent		dd ?
if _WIN32_IE ge 0400h
	pszHeaderTitle		dd ?	; this is displayed in the header
	pszHeaderSubTitle	dd ?	;
endif
ends

PSH_DEFAULT			= 000000000h
PSH_PROPTITLE			= 000000001h
PSH_USEHICON			= 000000002h
PSH_USEICONID			= 000000004h
PSH_PROPSHEETPAGE		= 000000008h
PSH_WIZARDHASFINISH		= 000000010h
PSH_WIZARD			= 000000020h
PSH_USEPSTARTPAGE		= 000000040h
PSH_NOAPPLYNOW			= 000000080h
PSH_USECALLBACK 		= 000000100h
PSH_HASHELP			= 000000200h
PSH_MODELESS			= 000000400h
PSH_RTLREADING			= 000000800h
PSH_WIZARDCONTEXTHELP		= 000001000h

;----- New flags for wizard97 -----------
PSH_WIZARD97			= 000002000h
; 0x00004000 was not used by any previous release
PSH_WATERMARK			= 000008000h
PSH_USEHBMWATERMARK		= 000010000h  ; user pass in a hbmWatermark instead of pszbmWatermark
PSH_USEHPLWATERMARK		= 000020000h  ;
PSH_STRETCHWATERMARK		= 000040000h  ; stretchwatermark also applies for the header
PSH_HEADER			= 000080000h
PSH_USEHBMHEADER		= 000100000h
PSH_USEPAGELANG 		= 000200000h  ; use frame dialog template matched to page
;----------------------------------------

;----- New flags for wizard-lite --------
PSH_WIZARD_LITE 		= 000400000h
;----------------------------------------

proctype FNPROPSHEETCALLBACK :dword, :dword, :dword

struc	PROPSHEETHEADER
	dwSize			dd ?
	dwFlags 		dd ?
	hwndParent		dd ?
	hInstance		dd ?
label	hIcon			dword
	pszIcon 		dd ?
	pszCaption		dd ?
	nPages			dd ?
label	nStartPage		dword
	pStartPage		dd ?
label	ppsp			dword
	phpage			dd ?
	pfnCallback		dd ?
if _WIN32_IE ge 0400h
label	hbmWatermark		dword
	pszbmWatermark		dd ?
	hplWatermark		dd ?
label	hbmHeader		dword	; Header  bitmap shares the palette with watermark
	pszbmHeader		dd ?
endif
ends

PSCB_INITIALIZED		= 1
PSCB_PRECREATE			= 2

procdesc CreatePropertySheetPageA :dword
procdesc DestroyPropertySheetPage :dword
procdesc PropertySheetA :dword

CreatePropertySheetPage 	equ <CreatePropertySheetPageA>
PropertySheet			equ <PropertySheetA>

proctype FNADDPROPSHEETPAGE :dword, :dword
proctype FNADDPROPSHEETPAGES :dword, :dword, :dword

struc	PSHNOTIFY
	hdr			NMHDR ?
	lParam			dd ?
ends

PSN_FIRST			= (0-200)
PSN_LAST			= (0-299)

PSN_SETACTIVE			= (PSN_FIRST-0)
PSN_KILLACTIVE			= (PSN_FIRST-1)
; #define PSN_VALIDATE		  (PSN_FIRST-1)
PSN_APPLY			= (PSN_FIRST-2)
PSN_RESET			= (PSN_FIRST-3)
; #define PSN_CANCEL		  (PSN_FIRST-3)
PSN_HELP			= (PSN_FIRST-5)
PSN_WIZBACK			= (PSN_FIRST-6)
PSN_WIZNEXT			= (PSN_FIRST-7)
PSN_WIZFINISH			= (PSN_FIRST-8)
PSN_QUERYCANCEL 		= (PSN_FIRST-9)
PSN_GETOBJECT			= (PSN_FIRST-10)
PSN_TRANSLATEACCELERATOR	= (PSN_FIRST-12)
PSN_QUERYINITIALFOCUS		= (PSN_FIRST-13)

PSNRET_NOERROR			= 0
PSNRET_INVALID			= 1
PSNRET_INVALID_NOCHANGEPAGE	= 2
PSNRET_MESSAGEHANDLED		= 3

PSM_SETCURSEL			= (WM_USER + 101)
PSM_REMOVEPAGE			= (WM_USER + 102)
PSM_ADDPAGE			= (WM_USER + 103)
PSM_CHANGED			= (WM_USER + 104)
PSM_RESTARTWINDOWS		= (WM_USER + 105)
PSM_REBOOTSYSTEM		= (WM_USER + 106)
PSM_CANCELTOCLOSE		= (WM_USER + 107)
PSM_QUERYSIBLINGS		= (WM_USER + 108)
PSM_UNCHANGED			= (WM_USER + 109)
PSM_APPLY			= (WM_USER + 110)
PSM_SETTITLE			= (WM_USER + 111)
PSM_SETWIZBUTTONS		= (WM_USER + 112)

PSWIZB_BACK			= 000000001h
PSWIZB_NEXT			= 000000002h
PSWIZB_FINISH			= 000000004h
PSWIZB_DISABLEDFINISH		= 000000008h


PSM_PRESSBUTTON 		= (WM_USER + 113)

PSBTN_BACK			= 0
PSBTN_NEXT			= 1
PSBTN_FINISH			= 2
PSBTN_OK			= 3
PSBTN_APPLYNOW			= 4
PSBTN_CANCEL			= 5
PSBTN_HELP			= 6
PSBTN_MAX			= 6

PSM_SETCURSELID 		= (WM_USER + 114)
PSM_SETFINISHTEXT		= (WM_USER + 115)
PSM_GETTABCONTROL		= (WM_USER + 116)
PSM_ISDIALOGMESSAGE		= (WM_USER + 117)
PSM_GETCURRENTPAGEHWND		= (WM_USER + 118)
PSM_INSERTPAGE			= (WM_USER + 119)

ID_PSRESTARTWINDOWS		= 02h
ID_PSREBOOTSYSTEM		= (ID_PSRESTARTWINDOWS + 01h)

WIZ_CXDLG			= 276
WIZ_CYDLG			= 140

WIZ_CXBMP			= 80

WIZ_BODYX			= 92
WIZ_BODYCX			= 184

PROP_SM_CXDLG			= 212
PROP_SM_CYDLG			= 188

PROP_MED_CXDLG			= 227
PROP_MED_CYDLG			= 215

PROP_LG_CXDLG			= 252
PROP_LG_CYDLG			= 218
