;****************************************************************************\
;*									       *
;* winver.h -	 Version management functions, types, and definitions	       *
;*									       *
;*		 Include file for VER.DLL.  This library is		       *
;*		 designed to allow version stamping of Windows executable files*
;*		 and of special .VER files for DOS executable files.	       *
;*									       *
;*	    Copyright (c) 1993-1998, Microsoft Corp.  All rights reserved      *
;*									       *
;\****************************************************************************

; ----- Symbols -----
VS_FILE_INFO			= RT_VERSION
VS_VERSION_INFO 		= 1
VS_USER_DEFINED 		= 100

; ----- VS_VERSION.dwFileFlags -----
VS_FFI_SIGNATURE		= 0FEEF04BDh
VS_FFI_STRUCVERSION		= 000010000h
VS_FFI_FILEFLAGSMASK		= 00000003Fh

; ----- VS_VERSION.dwFileFlags -----
VS_FF_DEBUG			= 000000001h
VS_FF_PRERELEASE		= 000000002h
VS_FF_PATCHED			= 000000004h
VS_FF_PRIVATEBUILD		= 000000008h
VS_FF_INFOINFERRED		= 000000010h
VS_FF_SPECIALBUILD		= 000000020h

; ----- VS_VERSION.dwFileOS -----
VOS_UNKNOWN			= 000000000h
VOS_DOS 			= 000010000h
VOS_OS216			= 000020000h
VOS_OS232			= 000030000h
VOS_NT				= 000040000h

VOS__BASE			= 000000000h
VOS__WINDOWS16			= 000000001h
VOS__PM16			= 000000002h
VOS__PM32			= 000000003h
VOS__WINDOWS32			= 000000004h

VOS_DOS_WINDOWS16		= 000010001h
VOS_DOS_WINDOWS32		= 000010004h
VOS_OS216_PM16			= 000020002h
VOS_OS232_PM32			= 000030003h
VOS_NT_WINDOWS32		= 000040004h

; ----- VS_VERSION.dwFileType -----
VFT_UNKNOWN			= 000000000h
VFT_APP 			= 000000001h
VFT_DLL 			= 000000002h
VFT_DRV 			= 000000003h
VFT_FONT			= 000000004h
VFT_VXD 			= 000000005h
VFT_STATIC_LIB			= 000000007h

; ----- VS_VERSION.dwFileSubtype for VFT_WINDOWS_DRV -----
VFT2_UNKNOWN			= 000000000h
VFT2_DRV_PRINTER		= 000000001h
VFT2_DRV_KEYBOARD		= 000000002h
VFT2_DRV_LANGUAGE		= 000000003h
VFT2_DRV_DISPLAY		= 000000004h
VFT2_DRV_MOUSE			= 000000005h
VFT2_DRV_NETWORK		= 000000006h
VFT2_DRV_SYSTEM 		= 000000007h
VFT2_DRV_INSTALLABLE		= 000000008h
VFT2_DRV_SOUND			= 000000009h
VFT2_DRV_COMM			= 00000000Ah
VFT2_DRV_INPUTMETHOD		= 00000000Bh

; ----- VS_VERSION.dwFileSubtype for VFT_WINDOWS_FONT -----
VFT2_FONT_RASTER		= 000000001h
VFT2_FONT_VECTOR		= 000000002h
VFT2_FONT_TRUETYPE		= 000000003h

; ----- VerFindFile() flags -----
VFFF_ISSHAREDFILE		= 00001h

VFF_CURNEDEST			= 00001h
VFF_FILEINUSE			= 00002h
VFF_BUFFTOOSMALL		= 00004h

; ----- VerInstallFile() flags -----
VIFF_FORCEINSTALL		= 00001h
VIFF_DONTDELETEOLD		= 00002h

VIF_TEMPFILE			= 000000001h
VIF_MISMATCH			= 000000002h
VIF_SRCOLD			= 000000004h

VIF_DIFFLANG			= 000000008h
VIF_DIFFCODEPG			= 000000010h
VIF_DIFFTYPE			= 000000020h

VIF_WRITEPROT			= 000000040h
VIF_FILEINUSE			= 000000080h
VIF_OUTOFSPACE			= 000000100h
VIF_ACCESSVIOLATION		= 000000200h
VIF_SHARINGVIOLATION		= 000000400h
VIF_CANNOTCREATE		= 000000800h
VIF_CANNOTDELETE		= 000001000h
VIF_CANNOTRENAME		= 000002000h
VIF_CANNOTDELETECUR		= 000004000h
VIF_OUTOFMEMORY 		= 000008000h

VIF_CANNOTREADSRC		= 000010000h
VIF_CANNOTREADDST		= 000020000h

VIF_BUFFTOOSMALL		= 000040000h
VIF_CANNOTLOADLZ32		= 000080000h
VIF_CANNOTLOADCABINET		= 000100000h

; ----- Types and structures -----

struc	VS_FIXEDFILEINFO
	dwSignature		dd ?		; e.g. 0xfeef04bd
	dwStrucVersion		dd ?		; e.g. 0x00000042 = "0.42"
	dwFileVersionMS 	dd ?		; e.g. 0x00030075 = "3.75"
	dwFileVersionLS 	dd ?		; e.g. 0x00000031 = "0.31"
	dwProductVersionMS	dd ?		; e.g. 0x00030010 = "3.10"
	dwProductVersionLS	dd ?		; e.g. 0x00000031 = "0.31"
	dwFileFlagsMask 	dd ?		; = 0x3F for version "0.42"
	dwFileFlags		dd ?		; e.g. VFF_DEBUG | VFF_PRERELEASE
	dwFileOS		dd ?		; e.g. VOS_DOS_WINDOWS16
	dwFileType		dd ?		; e.g. VFT_DRIVER
	dwFileSubtype		dd ?		; e.g. VFT2_DRV_KEYBOARD
	dwFileDateMS		dd ?		; e.g. 0
	dwFileDateLS		dd ?		; e.g. 0
ends

; ----- Function prototypes -----

procdesc VerFindFileA :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword
procdesc VerInstallFileA :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword
procdesc GetFileVersionInfoSizeA :dword, :dword
procdesc GetFileVersionInfoA :dword, :dword, :dword, :dword
procdesc VerLanguageNameA :dword, :dword, :dword
procdesc VerQueryValueA :dword, :dword, :dword, :dword

VerFindFile			equ <VerFindFileA>
VerInstallFile			equ <VerInstallFileA>
GetFileVersionInfoSize		equ <GetFileVersionInfoSizeA>
GetFileVersionInfo		equ <GetFileVersionInfoA>
VerLanguageName 		equ <VerLanguageNameA>
VerQueryValue			equ <VerQueryValueA>
